package com.trace.ar.drawing.activity;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;
import androidx.viewpager2.adapter.FragmentStateAdapter;
import androidx.viewpager2.widget.ViewPager2;

import com.trace.ar.drawing.R;
import com.trace.ar.drawing.databinding.ActivityHomeBinding;
import com.trace.ar.drawing.fragment.FavoriteFragment;
import com.trace.ar.drawing.fragment.HomeFragment;
import com.trace.ar.drawing.helper.Utils;
import com.google.android.material.tabs.TabLayout;
import com.trace.ar.drawing.topon.AdManager;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class MainActivity extends AppCompatActivity {

    private ActivityHomeBinding binding;

    private List<Fragment> listFragment = new ArrayList<>();

    private String[] permissions;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Utils.setStatusBarTextColor(this, true);
        binding = ActivityHomeBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());

        AdManager.loadAllAd();

        listFragment.add(HomeFragment.newInstance());
        listFragment.add(FavoriteFragment.newInstance());
        onTabInit();
        binding.viewPager2.setUserInputEnabled(false);
        binding.viewPager2.setAdapter(new FragmentStateAdapter(this) {
            @NonNull
            @Override
            public Fragment createFragment(int position) {
                return listFragment.get(position);
            }

            @Override
            public int getItemCount() {
                return listFragment.size();
            }
        });
        bingTabVp();

    }


    private void bingTabVp() {
        binding.tab.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                ImageView icon = Objects.requireNonNull(tab.getCustomView()).findViewById(R.id.im_icon);
                icon.setSelected(true);
                binding.viewPager2.setCurrentItem(tab.getPosition());
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
                ImageView icon = Objects.requireNonNull(tab.getCustomView()).findViewById(R.id.im_icon);
                icon.setSelected(false);
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });
        binding.viewPager2.registerOnPageChangeCallback(new ViewPager2.OnPageChangeCallback() {
            @Override
            public void onPageSelected(int position) {
                super.onPageSelected(position);
                Objects.requireNonNull(binding.tab.getTabAt(position)).select();
            }
        });
    }


    private void onTabInit() {

        for (int i = 0; i < listFragment.size(); i++) {
            TabLayout.Tab tab = binding.tab.newTab();

            View inflate = LayoutInflater.from(this).inflate(R.layout.tab_view, null, false);
            ImageView icon = inflate.findViewById(R.id.im_icon);
            TextView textView = inflate.findViewById(R.id.textView);
            if (i == 0) {
                textView.setText(getString(R.string.tab_tv_home));
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.selector_tab_home));
            } else {
                textView.setText(getString(R.string.tab_tv_favorite));
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.selector_tab_favorite));
            }
            tab.setCustomView(inflate);
            binding.tab.addTab(tab);
        }

    }


}